// gibt ein file rueckwaerts aus

#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>

const       MAXBUFF = 1000;
#define MAX_PRO_LINE 10

FILE *inFile;
FILE *outFile;
int len;

char buf[MAXBUFF];
int array_format;
int count;

void replace(char * line, char * define, char * value)
{
 static char _line[1000];
 char * pos;
 int posi=0;
 pos=line;
 while (pos=strstr(pos,define))
 {
  posi=pos-line;
  strcpy(_line,line);
  *strstr(_line+posi,define)=(char)0;
  strcat(_line,value);
  strcat(_line,pos+strlen(define));
  strcpy(line,_line);
  pos=line+posi+strlen(value);
 }
}

int main( int argc, char* argv[] )
{
 int len;

 cout <<"\nCalling ";
 for (int ii=0;ii<argc;ii++)
   cout <<" "<<argv[ii];
 cout << "\n\n";
 if ( argc != 3 )
 {
  cout << "Usage: make_c <infile> <outfile>\n";
  return 0;
 }
 if (!strcmp(argv[1], argv[2]))
 {
  cout << "<infile> == <outfile>, NOT ALLOWED\n";
  return 1;
 }
 inFile=fopen(argv[1],"rt");
 if( !inFile )
 {
  cout << "A file error occured with " << argv[1] << "!\n";
  return 2;
 }
 outFile= fopen( argv[2],"wt");
 if( !outFile )
 {
  cout << "A file error occured with " << argv[2] << "!\n";
  return 2;
 }
 len=0;

 fprintf(outFile,"void out_decoder()\n");
 fprintf(outFile,"{\n");
 fprintf(outFile," FILE* outFile = get_dbOutFile();\n");
 fprintf(outFile," if (outFile != NULL)\n");
 fprintf(outFile," {\n");

 while( 1 )
 {
  if (fgets(buf,1000, inFile) == NULL)
   break;
  *strchr(buf,'\n') = 0;
  replace(buf,"\"","\\\"");
  fprintf(outFile,"  fprintf(outFile,\"%s\\n\");\n", buf);
 }
 fprintf(outFile,"  fprintf(outFile,\"\\n\");\n");
 fprintf(outFile," }\n");
 fprintf(outFile,"}\n");
 fprintf(outFile,"\n");


 fclose(outFile);
 fclose(inFile);
 return 0;
}

